'''
Created on May 31, 2021

@author: shuangyinli
'''

import numpy as np

phraselist = []
categorylist =[]

biswtmveclist =[]

def readbiswtm(dictionaryfilepath,theta_filepath):
    dictionaryfile = open(dictionaryfilepath,"r")
    theta_file = open(theta_filepath,"r")
    
    dic = {}
    wordlist = []
    veclist = []
    for word in dictionaryfile:
        wordlist.append(word.split(":")[1].lstrip().rstrip().strip())
    for vec in theta_file:
        temp = vec.lstrip().rstrip().strip().split()
        veclist.append(np.array(list(map(eval, temp)),dtype = 'float64'))
        
    if len(wordlist) != len(veclist):
        print("there exsits error")
        exit(0)
    
    for i in range(len(wordlist)):
        dic.setdefault(wordlist[i], veclist[i])
    
    for i in range(len(phraselist)):
        phrase = phraselist[i]
        category = categorylist[i]
        phrasevector = np.array([0 for i in range(100)], dtype = 'float32')
        
        wlist = phrase.lstrip().rstrip().strip().split()
        exsitnum = 0
        for w in wlist:
            if w in dic:
                exsitnum+=1
                phrasevector += np.array(dic[w.lstrip().rstrip().strip()], dtype = 'float32')
        if exsitnum >=1:
            temp3 = category + "##"
            for l in phrasevector:
                temp3+= str(l) + " "
            biswtmveclist.append(temp3)
    
    pass


if __name__ == '__main__':
    
    phrasefile = open("/Users/shuangyinli/Data/ProgrammableWeb/data/category_phrase.txt","r")
    
    for phrase in phrasefile:
        wordlist = phrase.split("##")
        ph = wordlist[1].lstrip().rstrip().strip()
        category = wordlist[0].lstrip().rstrip().strip()
        phraselist.append(ph)
        categorylist.append(category)
    
    dictionaryfilepath = "/Users/shuangyinli/Data/ProgrammableWeb/bi-SWTM/middle/dictionary.txt"
    theta_filepath = "/Users/shuangyinli/Data/ProgrammableWeb/bi-SWTM/middle/final.theta"
    readbiswtm(dictionaryfilepath,theta_filepath)
    
    outputvector = open("/Users/shuangyinli/Data/ProgrammableWeb/bi-SWTM/phrase/phrasevec_biswtm.txt","w")
    for item in biswtmveclist:
        outputvector.write(item + "\n")
    outputvector.close
    
    pass