
import re
import os
import os.path
import sys
import operator

# keep the cleaned dictionay from DictionaryOrignal
DICTIONARY=[]
# keep the orignal dictionay
DictionaryOrignal={}
stopwords = {}

def readstopwords():
    return {}.fromkeys([ line.rstrip() for line in open('./en_stopwords.txt', 'r') ])

def remove(abstract):
    abstract = re.sub("[^A-Za-z0123456789]", " ", abstract)
    
    ###remove a single word
    abstract=re.sub(' [a-zA-Z] ', ' ', abstract)
    abstract=re.sub('^[ ]*[a-zA-Z] ', ' ', abstract) 
    abstract=re.sub(' [a-zA-Z][ ]*$', ' ', abstract)

    abstract =  ' '.join(abstract.split())
    abstract = abstract.lower()
    return abstract

## get the dictionany
def OrignalDictionaryFunction(words):
    line = remove(words)
    for word in line.split():
        word = word.rstrip().lstrip()
        if word.rstrip() == '':
            continue
        if word in stopwords:
            continue
        if word not in DictionaryOrignal:
            DictionaryOrignal.setdefault(word,0)
            DictionaryOrignal[word] += 1
        else:
            DictionaryOrignal[word] += 1
            
            
def MakeDictionary(inputfile):
    for line in inputfile:
        text = line.split("##")[-1]
        OrignalDictionaryFunction(text)
    print("dic is over, now clean it.")
    for key,value in DictionaryOrignal.items():
        if value > 5:
            DICTIONARY.append(key)
    print("the dic size is " + str(len(DICTIONARY)))
    
def codeText(words):
    wordlist ={}
    for word in words.split():
        word = word.rstrip()
        if word in stopwords:
            continue
        if word in DICTIONARY:
            wordlist.setdefault(DICTIONARY.index(word),0)
            wordlist[DICTIONARY.index(word)] += 1
    return wordlist
    
def code(inputfile, categoryfile,searchfile, twtmoutputfile, ldaoutputfile):
    print("now begin to extract category")
    inputfile.seek(0)
    documentno =0
    textlist =[]
    for line1 in inputfile:
        textlist.append(line1.rstrip().lstrip())
        
    for line in textlist:
        items = line.split("##")
        text = items[-1]
        document = remove(text).replace(".", " ")
        wordlist = codeText(document)
        wordsno = len(wordlist)
        if wordsno < 5:
            continue
        if wordsno != 0:
            # category
            categoryfile.write(items[0] +"\n")
            categoryfile.flush()
            searchfile.write(items[-1].lstrip().rstrip() + "\n")
            searchfile.flush()
            
            #text
            twtmoutputfile.write(str(wordsno)+" ")
            for  w in wordlist:
                twtmoutputfile.write(str(w) +" ")
            twtmoutputfile.write("@ ")
            
            twtmoutputfile.write(str(wordsno)+" ")
            ldaoutputfile.write(str(wordsno)+" ")
            
            for w in wordlist:
                twtmoutputfile.write(str(w)+":"+str(wordlist[w])+" ")
                ldaoutputfile.write(str(w)+":" + str(wordlist[w]) +" ")
            ldaoutputfile.write("\n")
            twtmoutputfile.write("\n")
        
        documentno = documentno +1
        print("now begin to doc :" + str(documentno))       
        
    categoryfile.close()
    twtmoutputfile.close()
    ldaoutputfile.close()
    searchfile.close()

def code1(inputfile1, categoryfile1, ldaoutputfile1):
    print("now begin to extract category")
    inputfile1.seek(0)
    documentno =0
    textlist =[]
    for line1 in inputfile1:
        textlist.append(line1.rstrip().lstrip())
        
    for line in textlist:
        items = line.split("##")
        text = items[-1]
        document = remove(text).replace(".", " ")
        wordlist = codeText(document)
        wordsno = len(wordlist)
        if wordsno < 3:
            continue
        if wordsno != 0:
            # category
            categoryfile1.write(items[0] +"\n")
            categoryfile1.flush()
            
            ldaoutputfile1.write(str(wordsno)+" ")
            
            for w in wordlist:
                ldaoutputfile1.write(str(w)+":" + str(wordlist[w]) +" ")
            ldaoutputfile1.write("\n")
        
        documentno = documentno +1
        print("now begin to doc :" + str(documentno))       
        
    categoryfile1.close()
    ldaoutputfile1.close()

def SaveDictionary(dicfile):
    print("now save the dictionary.")
    for word in DICTIONARY:
        dicfile.write(str(DICTIONARY.index(word)) +":" +word)
        dicfile.write("\n")
    dicfile.close()

if __name__ == '__main__':
    #read stopwords
    stopwords = readstopwords()
    #input file: catogary##content        
    #inputfile = open("/Users/huihui/data/wiki/purepagespart.txt","r", encoding = "utf-8")
    inputfile = open(sys.argv[1],"r", encoding = "utf-8")
    oDir = sys.argv[3]
    #output: twtm code or lda code
    twtmoutputfile = open(oDir+"/twtmcode.txt","w", encoding = "utf-8")
    ldaoutputfile = open(oDir+"/ldacode.txt","w", encoding = "utf-8")
    categoryfile = open(oDir+"/cagegory.txt","w", encoding = "utf-8")
    searchfile = open(oDir+"/originalForsearch.txt","w", encoding = "utf-8")
    dicfile = open(oDir+"/dictionary.txt","w", encoding = "utf-8")
    
    inputfile1 = open(sys.argv[2],"r", encoding = "utf-8")
    ldaoutputfile1 = open(oDir+"/ldacode1.txt","w", encoding = "utf-8")
    categoryfile1 = open(oDir+"/cagegory1.txt","w", encoding = "utf-8")
    # make the dictionary
    MakeDictionary(inputfile)
    SaveDictionary(dicfile)
    
    #extractCategory(inputfile, categoryfile)
    #RBMcode(inputfile,rbmoutputfile)
    #LDAcode(inputfile, ldaoutputfile)
    
    code(inputfile, categoryfile, searchfile,twtmoutputfile, ldaoutputfile)
    code1(inputfile1,categoryfile1, ldaoutputfile1)
    
    print("end.")