'''
Created on May 27, 2021

@author: shuangyinli
'''

import random
import re
import operator
import logging
import sys
import re
import time
import os

import lightgbm as lgb
from numpy import *
import numpy as np
import operator
import random
import copy
import sys
import re
import time
import os
from multiprocessing import Process, Manager
from copy import deepcopy
from collections import Counter

from sklearn.metrics import precision_score, recall_score, f1_score,accuracy_score
from sklearn.model_selection import cross_validate
from sklearn.model_selection import GridSearchCV
from sklearn.model_selection import train_test_split, StratifiedKFold
from sklearn import metrics
import pandas as pd
from sklearn.model_selection import KFold
from sklearn.model_selection import train_test_split
from sklearn import datasets

logging.basicConfig(format='%(asctime)s : %(levelname)s : %(message)s', level=logging.INFO)
from gensim.models import Word2Vec
import gensim.downloader as api
from gensim.test.utils import datapath
from gensim.models.word2vec import LineSentence
from gensim.models.word2vec import Text8Corpus
from gensim.models.word2vec import KeyedVectors
from gensim import downloader
import numpy as np


stopwords = {}

# keep the cleaned dictionay from DictionaryOrignal
DICTIONARY=[]

# keep the orignal dictionay
DictionaryOrignal={}
categories = []
select_category = []

global model

def kfold(X,Y, n_splits=5):
    kf = KFold(n_splits,shuffle=True,random_state=None)

    f1Num = []
    accNum = []
    scoreNum =[]
    for k, (train, test) in enumerate(kf.split(X,Y)):
        X_train = X.iloc[train]
        X_test = X.iloc[test]
        Y_train = Y.iloc[train]
        Y_test = Y.iloc[test]
        f1value, acc, score = train_lightGBM(X_train, Y_train,X_test, Y_test)
        print("Fold "+str(k) +":")
        print("f1:" + str(f1value) +" Accuracy: "+ str(acc) + " Score: "+str(score))
        f1Num.append(f1value)
        accNum.append(acc)
        scoreNum.append(score)
    
    print("The f1 of the vectors is : \n")
    print(str(np.sum(f1Num) / n_splits) + " f1  std : " + str(np.std(f1Num)))
    print("------------")
    print("The accuracy of the vectors is : \n")
    print(str(np.sum(accNum) / n_splits) + " accuracy std: " + str(np.std(accNum)))
    print("------------")
    print("The score of the vectors is : \n")
    print(str(np.sum(scoreNum) / n_splits) + " score std: " + str(np.std(scoreNum)))
    print("*****************")
    
def train_lightGBM(X_train, y_train,X_test, y_test):
    model_lgb = lgb.LGBMClassifier(boosting_type='goss', num_leaves=1000, learning_rate=0.01, n_estimators=2000, max_depth=-1,
                                   metric='multiclass',min_child_samples=30)
    
    model_lgb.fit(X_train,y_train)
    y_pred = model_lgb.predict(X_test)
    
    f1value = f1_score(y_test, y_pred,average="weighted")
    acc = accuracy_score(y_test, y_pred)
    score = model_lgb.score(X_test, y_test)
    return f1value, acc, score

def train_lightGBM_cv(train_data):
    params = {
        'objective': 'binary',
        'learning_rate': 0.1,
        'num_leaves': 31,
        'tree_learner':'feature',
        'num_threads': 6,
        'metric': 'binary_logloss',
        'max_depth': -1,
        'min_child_samples': 25
    }  # 设置出参数
    
    num_round = 10
    
    model = lgb.cv(params = params, train_set = train_data, num_boost_round = 200, 
           nfold=5,early_stopping_rounds=10)
    print(model.best_params_, model.best_score_)


def classify(index):
    all_senvector1 = [];
    Labels = []
    labelid = []
    
    for line in index:
        linelist = line.lstrip().rstrip().strip().split("##")
        label = linelist[0]
        textlist = linelist[-1].lstrip().rstrip().strip().split()
        sentencevector = np.array([0 for i in range(100)], dtype = 'float64')
        for word in textlist:
            w = word.lstrip().rstrip().strip()
            if w in model.wv:
                wvw = np.array(model.wv[w])
                sentencevector += wvw
        labelid.append(select_category.index(label))
        all_senvector1.append(sentencevector)
                
    x_data = np.array(all_senvector1)
    y_data = np.array(labelid)
    
    print("begin to classify")
    
    #train_data = lgb.Dataset(data=x_data,label=y_data)
    
    X_train = pd.DataFrame(x_data,dtype = 'float')
    Y_train = pd.DataFrame(y_data,dtype = 'int')
    
    kfold(X_train,Y_train)
    
    #train_lightGBM(X_train,Y_train)
    print("done")


## get the dictionany
def OrignalDictionaryFunction(words):
    line = remove(words)
    for word in line.split():
        word = word.rstrip().lstrip()
        if word.rstrip() == '':
            continue
        if word in stopwords:
            continue
        if word not in DictionaryOrignal:
            DictionaryOrignal.setdefault(word,0)
            DictionaryOrignal[word] += 1
        else:
            DictionaryOrignal[word] += 1
            
def MakeDictionary(inputfile):
    for line in inputfile:
        text = line.split("##")[-1]
        OrignalDictionaryFunction(text)
    print("dic is over, now clean it.")
    for key,value in DictionaryOrignal.items():
        if value > 5:
            DICTIONARY.append(key)
    print("the dic size is " + str(len(DICTIONARY)))

def readstopwords():
    return {}.fromkeys([ line.rstrip() for line in open('./en_stopwords.txt', 'r') ])

def remove(abstract):
    abstract = re.sub("[^A-Za-z.0123456789]", " ", abstract)
    
    ###remove a single word
    abstract=re.sub(' [a-zA-Z] ', ' ', abstract)
    abstract=re.sub('^[ ]*[a-zA-Z] ', ' ', abstract) 
    abstract=re.sub(' [a-zA-Z][ ]*$', ' ', abstract)

    abstract =  ' '.join(abstract.split())
    abstract = abstract.lower()
    return abstract


if __name__ == '__main__':
    
    if (len(sys.argv) != 3 and len(sys.argv) != 2):
        print(" python *.py <inputfile> <pretrain_wiki>")
        print(" ")
        exit(0)
    
    inputfile_path = sys.argv[1]
    
    if len(sys.argv) == 3:
        pretrain_wiki_file = sys.argv[2]
    if len(sys.argv) == 2:
        pretrain_wiki_file = ''
    
    stopwords = readstopwords()
    
    inputfile = open(sys.argv[1], "r", encoding = "utf-8")
    
    MakeDictionary(inputfile)
    inputfile.seek(0)
    rand_linedic = {}
    textlist = []
    select_out_category = {}
    for line in inputfile:
        label = line.split("##")[0].lstrip().rstrip().strip()
        categories.append(label)
        if label not in select_out_category:
            select_out_category.setdefault(label, 1)
        else:
            select_out_category[label] +=1
    
    log_sorted = sorted(select_out_category.items(), key=operator.itemgetter(1),  reverse=True)[:30]
    
    for item in log_sorted:
        select_category.append(item[0])
    print(select_category)
    
    inputfile.seek(0)
    for line in inputfile:
        label = line.split("##")[0].lstrip().rstrip().strip()
        text = line.split("##")[1].lstrip().rstrip().strip()
        temp = remove(text).split()
        wc = 0
        for w in temp:
            if w in DICTIONARY:
                wc += 1
        
        if label in select_category:
            rand_linedic.setdefault(line.lstrip().rstrip().strip(), wc)
        
        
    #ranked_linedic = sorted(rand_linedic.items(), key=operator.itemgetter(1),  reverse=False)
    
    inputfile.seek(0)
    model = Word2Vec(window=5, min_count=1, workers=7)
    
    if pretrain_wiki_file != '' and pretrain_wiki_file != ' ':
        print("pretrain word2vec model from wiki")
        sentences = LineSentence(datapath(pretrain_wiki_file))  
        model = Word2Vec(sentences=sentences,window=5, min_count=1, workers=7)
        print("done pretrain")
        print("begin re_train with service descriptions.")
        more_sentences = LineSentence(datapath(inputfile_path))
        model.build_vocab(more_sentences, update=True)
        model.train(more_sentences, total_examples=model.corpus_count, epochs=model.epochs)
        print("end re_train")
    else:
        print("train with the service descriptions directly")
        sentences = LineSentence(datapath(inputfile_path))
        model = Word2Vec(sentences=sentences,window=5, min_count=1, workers=7)
    
    c1 = []
    d1 = []
    a1 = []
    b1 = []
    
    for k,v in rand_linedic.items():    
        if v > 20 and v <= 30:
            a1.append(k)
        elif v > 30 and v <= 40:
            b1.append(k)
        elif v > 40 and v < 50:
            c1.append(k)
        elif v >= 50 and v <= 1000000:
            d1.append(k)
    
    print(len(c1))
    print(len(d1))
    print(len(a1))
    print(len(b1))

    random.shuffle(c1)
    random.shuffle(d1)
    random.shuffle(a1)
    random.shuffle(b1)
    
    a = a1[:1000]
    b = b1[:1000]
    c = c1[:1000]
    d = d1[:1000]

    classify(a)
    
    classify(b)
    
    classify(c)
    
    classify(d)
    
    print("done")
