'''
Created on May 27, 2021

@author: shuangyinli
'''

import random
import re
import operator
import logging
import sys
import re
import time
import os

logging.basicConfig(format='%(asctime)s : %(levelname)s : %(message)s', level=logging.INFO)
from gensim.models import Word2Vec
import gensim.downloader as api
from gensim.test.utils import datapath
from gensim.models.word2vec import LineSentence
from gensim.models.word2vec import Text8Corpus
from gensim.models.word2vec import KeyedVectors
from gensim import downloader
import numpy as np


stopwords = {}

# keep the cleaned dictionay from DictionaryOrignal
DICTIONARY=[]

# keep the orignal dictionay
DictionaryOrignal={}

global model

## get the dictionany
def OrignalDictionaryFunction(words):
    line = remove(words)
    for word in line.split():
        word = word.rstrip().lstrip()
        if word.rstrip() == '':
            continue
        if word in stopwords:
            continue
        if word not in DictionaryOrignal:
            DictionaryOrignal.setdefault(word,0)
            DictionaryOrignal[word] += 1
        else:
            DictionaryOrignal[word] += 1
            
def MakeDictionary(inputfile):
    for line in inputfile:
        text = line.split("##")[-1]
        OrignalDictionaryFunction(text)
    print("dic is over, now clean it.")
    for key,value in DictionaryOrignal.items():
        if value > 5:
            DICTIONARY.append(key)
    print("the dic size is " + str(len(DICTIONARY)))

def readstopwords():
    return {}.fromkeys([ line.rstrip() for line in open('./en_stopwords.txt', 'r') ])

def remove(abstract):
    abstract = re.sub("[^A-Za-z.0123456789]", " ", abstract)
    
    ###remove a single word
    abstract=re.sub(' [a-zA-Z] ', ' ', abstract)
    abstract=re.sub('^[ ]*[a-zA-Z] ', ' ', abstract) 
    abstract=re.sub(' [a-zA-Z][ ]*$', ' ', abstract)

    abstract =  ' '.join(abstract.split())
    abstract = abstract.lower()
    return abstract


if __name__ == '__main__':
    
    if (len(sys.argv) != 4 and len(sys.argv) != 3):
        print(" python *.py <inputfile> <model_root> <pretrain_wiki>")
        print(" ")
        exit(0)
    
    inputfile_path = sys.argv[1]

    model_root = sys.argv[2]
    
    if len(sys.argv) == 4:
        pretrain_wiki_file = sys.argv[3]
    if len(sys.argv) == 3:
        pretrain_wiki_file = ''
    
    stopwords = readstopwords()
    
    inputfile = open(sys.argv[1], "r", encoding = "utf-8")
    
    MakeDictionary(inputfile)
    inputfile.seek(0)
    textlist = []
    for line in inputfile:
        temp = remove(line.lstrip().rstrip()).split()
        wc = 0
        for w in temp:
            if w in DICTIONARY:
                wc += 1
        textlist.append(line.lstrip().rstrip())
    
    inputfile.seek(0)
    model = Word2Vec(window=5, min_count=1, workers=7)
    
    if pretrain_wiki_file != '' and pretrain_wiki_file != ' ':
        print("pretrain word2vec model from wiki")
        sentences = LineSentence(datapath(pretrain_wiki_file))  
        model = Word2Vec(sentences=sentences,window=5, min_count=1, workers=7)
        print("done pretrain")
        print("begin re_train with service descriptions.")
        more_sentences = LineSentence(datapath(inputfile_path))
        model.build_vocab(more_sentences, update=True)
        model.train(more_sentences, total_examples=model.corpus_count, epochs=model.epochs)
        print("end re_train")
    else:
        print("train with the service descriptions directly")
        sentences = LineSentence(datapath(inputfile_path))
        model = Word2Vec(sentences=sentences,window=5, min_count=1, workers=7)
    
    
    outputw2vector = open(model_root +"para_word2vector.txt", "w", encoding = "utf-8")
    
    print("conduct the average vectors of the service descriptions")
        
    for line in textlist:
        items = line.split("##")
        textlist = items[-1].lstrip().rstrip().split()
        label = items[0]
        sentencevector = np.array([0 for i in range(100)], dtype = 'float64')
        for word in textlist:
            if word in model.wv:
                wvw = np.array(model.wv[word])
                sentencevector += wvw
        
        outputw2vector.write(label + "##")
        for i in range(100):
            outputw2vector.write(str(sentencevector[i])+ " ")
        outputw2vector.write("\n")
        
    outputw2vector.close()
    
    print("done")
